# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`postgresql_userconfig`](#postgresql_userconfig): main class to generate postgres passfiles

### Defined types

* [`postgresql_userconfig::passfile`](#postgresql_userconfig--passfile): initialize a passfile
* [`postgresql_userconfig::passfile_entry`](#postgresql_userconfig--passfile_entry): add an entry (line) in one ore more pgpass files

## Classes

### <a name="postgresql_userconfig"></a>`postgresql_userconfig`

main class to generate postgres passfiles

#### Examples

##### 

```puppet
include postgresql_passfile
```

#### Parameters

The following parameters are available in the `postgresql_userconfig` class:

* [`passfiles`](#-postgresql_userconfig--passfiles)
* [`passfiles_defaults`](#-postgresql_userconfig--passfiles_defaults)
* [`passfile_entries`](#-postgresql_userconfig--passfile_entries)
* [`passfile_entries_defaults`](#-postgresql_userconfig--passfile_entries_defaults)

##### <a name="-postgresql_userconfig--passfiles"></a>`passfiles`

Data type: `Hash`

Hash to create the files, see postgresql_userconfig::passfile
for keys to use.
in hiera this parameter is hash merged

Default value: `{}`

##### <a name="-postgresql_userconfig--passfiles_defaults"></a>`passfiles_defaults`

Data type: `Hash`

use this if you want any defaults changed for the files.

Default value: `{}`

##### <a name="-postgresql_userconfig--passfile_entries"></a>`passfile_entries`

Data type: `Hash`

Hash to create file entries, see postgresql_userconfig::passfile_entry
for keys to use.
in hiera this parameter is hash merged

Default value: `{}`

##### <a name="-postgresql_userconfig--passfile_entries_defaults"></a>`passfile_entries_defaults`

Data type: `Hash`

use this if you want any defaults changed for the entries.

Default value: `{}`

## Defined types

### <a name="postgresql_userconfig--passfile"></a>`postgresql_userconfig::passfile`

initialize a passfile

#### Examples

##### 

```puppet
postgresql_userconfig::passfile { 'namevar': }
```

#### Parameters

The following parameters are available in the `postgresql_userconfig::passfile` defined type:

* [`filepath`](#-postgresql_userconfig--passfile--filepath)
* [`filename`](#-postgresql_userconfig--passfile--filename)
* [`owner`](#-postgresql_userconfig--passfile--owner)
* [`group`](#-postgresql_userconfig--passfile--group)
* [`mode`](#-postgresql_userconfig--passfile--mode)

##### <a name="-postgresql_userconfig--passfile--filepath"></a>`filepath`

Data type: `String`

the path to use for the file to write,
normaly the homedirectory of the user.
but puppet cannot (yet ?) detect your'e home,
so we make this a parameter

##### <a name="-postgresql_userconfig--passfile--filename"></a>`filename`

Data type: `String`

filename to write

Default value: `'.pgpass'`

##### <a name="-postgresql_userconfig--passfile--owner"></a>`owner`

Data type: `String`

owner of the file (defaults to the title)

Default value: `$title`

##### <a name="-postgresql_userconfig--passfile--group"></a>`group`

Data type: `Optional[String]`

group of the file.

Default value: `undef`

##### <a name="-postgresql_userconfig--passfile--mode"></a>`mode`

Data type: `String`

the mode of the file

Default value: `'0600'`

### <a name="postgresql_userconfig--passfile_entry"></a>`postgresql_userconfig::passfile_entry`

lets you define a line entry in the pgpass file
for simplification, you can define multiple targets.

#### Examples

##### 

```puppet
postgresql_userconfig::passfile_entry { 'namevar': }
```

#### Parameters

The following parameters are available in the `postgresql_userconfig::passfile_entry` defined type:

* [`targets`](#-postgresql_userconfig--passfile_entry--targets)
* [`comment`](#-postgresql_userconfig--passfile_entry--comment)
* [`hostname`](#-postgresql_userconfig--passfile_entry--hostname)
* [`port`](#-postgresql_userconfig--passfile_entry--port)
* [`database`](#-postgresql_userconfig--passfile_entry--database)
* [`username`](#-postgresql_userconfig--passfile_entry--username)
* [`password`](#-postgresql_userconfig--passfile_entry--password)
* [`order`](#-postgresql_userconfig--passfile_entry--order)

##### <a name="-postgresql_userconfig--passfile_entry--targets"></a>`targets`

Data type: `Variant[String, Array]`

the title of the target passfile. this can also
be an array, if you like to add a database to several
pgpass files.

Default value: `[]`

##### <a name="-postgresql_userconfig--passfile_entry--comment"></a>`comment`

Data type: `Optional[String]`

a simple comment to add to the file prior to the entry

Default value: `undef`

##### <a name="-postgresql_userconfig--passfile_entry--hostname"></a>`hostname`

Data type: `String`

the hostname entry

Default value: `'*'`

##### <a name="-postgresql_userconfig--passfile_entry--port"></a>`port`

Data type: `String`

the port entry

Default value: `'5432'`

##### <a name="-postgresql_userconfig--passfile_entry--database"></a>`database`

Data type: `String`

the database entry

Default value: `$title`

##### <a name="-postgresql_userconfig--passfile_entry--username"></a>`username`

Data type: `String`

the username entry

Default value: `'*'`

##### <a name="-postgresql_userconfig--passfile_entry--password"></a>`password`

Data type: `Optional[String]`

the password entry

Default value: `undef`

##### <a name="-postgresql_userconfig--passfile_entry--order"></a>`order`

Data type: `String`

the order in the file

Default value: `'100'`

